---
image: registry.gitlab.com/guardianproject-ops/docker-python-node:python3.8-nodejs14

services:
  - postgres:13

variables:
  CI: "true"
  POSTGRES_PASSWORD: amigo
  POSTGRES_USER: postgres
  POSTGRES_PORT: 5432
  POSTGRES_HOST: postgres
  DATABASE_NAME: amigo_test
  DATABASE_OWNER: amigo
  DATABASE_OWNER_PASSWORD: amigo
  AMIGO_CONFIG: ${CI_PROJECT_DIR}/.test.ci.json

stages:
  - build
  - test
  - docker-build
  - docker-release

cache:
  untracked: true
  key: "$CI_BUILD_REF_NAME"
  paths:
    - node_modules/
    - "@app/api/build"
    - "@app/frontend/build"
    - "@app/cli/build"
    - "@app/config/build"
    - "@app/db/build"
    - "@app/worker/build"
    - "/root/.cache/Cypress"

.setup_test_env: &setup_test_env
  before_script:
    - ./@app/db/scripts/bootstrap.sh

.run_test: &run_test
  script:
    - echo Current package is ${PKG}
    - make ${PKG}/test
  artifacts:
    paths:
      - "@app/${PKG}/coverage"

build:
  stage: build
  <<: *setup_test_env
  script:
    - make build

test-api:
  stage: test
  variables:
    PKG: api
  <<: *setup_test_env
  <<: *run_test

test-worker:
  stage: test
  variables:
    PKG: worker
  <<: *setup_test_env
  <<: *run_test

test-frontend:
  stage: test
  variables:
    PKG: frontend
  <<: *setup_test_env
  <<: *run_test

test-e2e:
  image: cypress/browsers:node14.15.0-chrome86-ff82
  stage: test
  variables:
    PKG: e2e
  before_script:
    - apt-get update && apt-get install -y postgresql-client make
    - ./@app/db/scripts/bootstrap.sh
    - npx cypress install
  script:
    - ./cli api &
    - ./cli worker &
    - yarn workspace @app/frontend dev &
    - make e2e/test

test-everything-else:
  stage: test
  script:
    - make config/test db/test cli/test
docker-build:
  image: docker:git
  services:
    - docker:dind
  stage: docker-build
  variables:
    DOCKER_NS: ${CI_REGISTRY_IMAGE}
    DOCKER_TAG: ${CI_COMMIT_SHORT_SHA}
  script:
    - apk add --update make
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - make docker/build-fresh-push

docker-release:
  image: docker:git
  services:
    - docker:dind
  stage: docker-release
  variables:
    DOCKER_NS: ${CI_REGISTRY_IMAGE}
    DOCKER_TAG: ${CI_COMMIT_SHORT_SHA}
    DOCKER_TAG_NEW: ${CI_COMMIT_REF_NAME}
  only:
    - master
    - develop
  script:
    - apk add --update make
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - make docker/add-tag
